<?php
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST");
header("Access-Control-Allow-Headers: Content-Type");

if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
	exit;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
	$shopId = '0603961452548022689baa6ef19928';
	$shopSecret = '3b53006027f66e13667b8480d9cd8f69';

	if (isset($_POST['email'])) {

	    // Получение значений переменных из POST-запроса
	    $email = $_POST['email'];
	    //$email = 'testmail4@gmail.com';

		// дальнейшие действия с полученным идентификатором устройства
		$url = "https://api.rees46.ru/subscriptions/check?shop_id={$shopId}&shop_secret={$shopSecret}&email={$email}";

		$ch = curl_init($url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$response = curl_exec($ch);
		curl_close($ch);

		$exists = false;
		$email_bulk = false;
		$email_suppressed = false;
		$has_orders = false;

		$message = false;
		$status = false;
		$segment = false;

		if ($response) {
			$result = json_decode($response, true);
			//echo $response;

			// Проверка статуса подписки по электронной почте
			if ($result['exists']) {
				//echo "Пользователь существует.<br>";
				$exists = true;
			}

			// Проверка других статусов подписки, если необходимо
			if ($result['email_bulk']) {
				//echo "Подписка на рассылку по электронной почте.<br>";
				$email_bulk = true;
			}
			if ($result['email_suppressed']) {
				//echo "Пользоатель отписан.<br>";
				$email_suppressed = true;
			}


			// Узнаем есть ли заказы у клиента через апи инсалес
			$api_key = 'https://3e4fc58874f1de71481551b3b9623771:9a3ff937ebca217cdf00b704e40c5f32@www.bunglyboo.ru';
			$authToken = "Basic ZGlnaXRhbC1nb29kczpjNTFjOTA3MDdhMTNjZTNmZmYyMTNhZmJiNWNkMTI3MA==";
			$data_string = json_encode($data);

			$ch_insales = curl_init();
			curl_setopt($ch_insales, CURLOPT_URL, "".$api_key."/admin/orders.json?q=".$email."");
			curl_setopt($ch_insales, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch_insales, CURLOPT_CUSTOMREQUEST, "GET");
			curl_setopt($ch_insales, CURLOPT_POST, true);
			curl_setopt($ch_insales, CURLOPT_POSTFIELDS, $data_string);
			curl_setopt($ch_insales, CURLOPT_HEADER, false);
			curl_setopt($ch_insales, CURLOPT_HTTPHEADER, array(
			'Content-Type:application/json',
			'Content-Length: ' . strlen($data_string),
			'cache-control: no-cache',
			'API-TOKEN-KEY:'.$authToken ));
			$output = curl_exec($ch_insales);
			if ($output === FALSE){
			die(curl_error($ch_insales));
			$status = 'error';
			}
			curl_close($ch_insales);

			$objects = json_decode($output);

			foreach ($objects as $object) {
			if (isset($object->client) && isset($object->client->email) && $object->client->email === $email) {
			    $has_orders = true;
			    break; // Если найдено совпадение, выходим из цикла
			}
			}


		} else {
		  // Ошибка при выполнении запроса
		  $status = 'error';
		}


		// Проверяем статусы и записываем пользователя в нужный сегмент
		if (!$email_bulk && !$email_suppressed) {
			$userData = array(
			    'shop_id' => $shopId,
			    'shop_secret' => $shopSecret,
			    'email' => $email,
			    'segment_id' => '18480'
			);
			$jsonData = json_encode($userData);
			$curl = curl_init();
			$url = 'https://api.rees46.ru/segments/add';
			$headers = array(
			    'Content-Type: application/json'
			);
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $jsonData);
			$response = curl_exec($curl);
			curl_close($curl);

			$message = $response;
			$status = true;
			$segment = '18480';
		} else if ($email_bulk && !$email_suppressed && !$has_orders) {
			$userData = array(
			    'shop_id' => $shopId,
			    'shop_secret' => $shopSecret,
			    'email' => $email,
			    'segment_id' => '18470'
			);
			$jsonData = json_encode($userData);
			$curl = curl_init();
			$url = 'https://api.rees46.ru/segments/add';
			$headers = array(
			    'Content-Type: application/json'
			);
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $jsonData);
			$response = curl_exec($curl);
			curl_close($curl);

			$message = $response;
			$status = true;
			$segment = '18470';
		} else if ($exists && $email_suppressed) {
			$userData = array(
			    'shop_id' => $shopId,
			    'shop_secret' => $shopSecret,
			    'email' => $email,
			    'segment_id' => '18261'
			);
			$jsonData = json_encode($userData);
			$curl = curl_init();
			$url = 'https://api.rees46.ru/segments/add';
			$headers = array(
			    'Content-Type: application/json'
			);
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $jsonData);
			$response = curl_exec($curl);
			curl_close($curl);

			$message = $response;
			$status = true;
			$segment = '18261';
		} else if ($exists && $email_bulk && !$email_suppressed && $has_orders) {
			$userData = array(
			    'shop_id' => $shopId,
			    'shop_secret' => $shopSecret,
			    'email' => $email,
			    'segment_id' => '18262'
			);
			$jsonData = json_encode($userData);
			$curl = curl_init();
			$url = 'https://api.rees46.ru/segments/add';
			$headers = array(
			    'Content-Type: application/json'
			);
			curl_setopt($curl, CURLOPT_URL, $url);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
			curl_setopt($curl, CURLOPT_POST, true);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $jsonData);
			$response = curl_exec($curl);
			curl_close($curl);

			$message = $response;
			$status = true;
			$segment = '18262';
		}

		$return = array(
		  'mail' => $email,
		  'result' => $result,
		  'objects' => $objects,
		  'has_orders' => $has_orders,
		  'message' => $message,
		  'status' => $status,
		  'segment' => $segment
		);

		// Установка заголовка для указания типа данных (JSON)
		header('Content-Type: application/json');

		// Отправка массива с переменными в виде JSON
		echo json_encode($return);

	}

}
?>